Socket::UNIXAddress - Crystal 1.21.0

# struct Socket::UNIXAddress

- Socket::UNIXAddress
- Socket::Address
- Struct
- Value
- Object

##
Overview

UNIX address representation.

Holds the local path of an UNIX address, usually coming from an opened connection (e.g. `Socket#local_address`, `Socket#receive`).

Example:

    require "socket"

    Socket::UNIXAddress.new("/tmp/my.sock")

##
Defined in:

socket/address.cr

##
Constructors

- .from(sockaddr : Pointer(LibC::Sockaddr), addrlen) : UNIXAddress

  Creates an `UNIXSocket` from the internal OS representation.

- .from(sockaddr : Pointer(LibC::Sockaddr)) : UNIXAddress

  Creates an `UNIXSocket` from the internal OS representation.

- .new(path : Path | String)
- .parse(uri : URI) : UNIXAddress

  Parses a `Socket::UNIXAddress` from an URI.

- .parse(uri : String) : self

  Parses a `Socket::UNIXAddress` from an URI.

##
Instance Method Summary

- #==(other : self)
- #hash(hasher)

  See `Object#hash(hasher)`

- #path : String
- #to_s(io : IO) : Nil

  Same as `#inspect(io)`.

- #to_unsafe : Pointer(LibC::Sockaddr)

### Instance methods inherited from struct `Socket::Address`

family : Family family, size : Int32 size, to_unsafe : Pointer(LibC::Sockaddr) to_unsafe

### Constructor methods inherited from struct `Socket::Address`

from(sockaddr : Pointer(LibC::Sockaddr), addrlen) : Address
from(sockaddr : Pointer(LibC::Sockaddr)) : Address from, new(family : Family, size : Int32) new, parse(uri : URI) : self
parse(uri : String) : self parse

### Instance methods inherited from struct `Struct`

==(other : YAML::Any)
==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Class methods inherited from struct `Struct`

pre_initialize(address : Pointer) : Nil pre_initialize

### Instance methods inherited from struct `Value`

==(other : Log::Metadata::Value)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.from(sockaddr : Pointer(LibC::Sockaddr), addrlen) : UNIXAddress #

Creates an `UNIXSocket` from the internal OS representation.

def self.from(sockaddr : Pointer(LibC::Sockaddr)) : UNIXAddress #

Creates an `UNIXSocket` from the internal OS representation.

def self.new(path : Path | String) #
def self.parse(uri : URI) : UNIXAddress #

Parses a `Socket::UNIXAddress` from an URI.

It expects the URI to include `<scheme>://<path>` where `scheme` as well as any additional URI components (such as `fragment` or `query`) are ignored.

If `host` is not empty, it will be prepended to `#path` to form a relative path.

    require "socket"

    Socket::UNIXAddress.parse("unix:///foo.sock") # => Socket::UNIXAddress.new("/foo.sock")
    Socket::UNIXAddress.parse("unix://foo.sock")  # => Socket::UNIXAddress.new("foo.sock")

def self.parse(uri : String) : self #

Parses a `Socket::UNIXAddress` from an URI.

It expects the URI to include `<scheme>://<path>` where `scheme` as well as any additional URI components (such as `fragment` or `query`) are ignored.

If `host` is not empty, it will be prepended to `#path` to form a relative path.

    require "socket"

    Socket::UNIXAddress.parse("unix:///foo.sock") # => Socket::UNIXAddress.new("/foo.sock")
    Socket::UNIXAddress.parse("unix://foo.sock")  # => Socket::UNIXAddress.new("foo.sock")

##
Instance Method Detail

def ==(other : self) #
def hash(hasher) #
Description copied from struct Struct

See `Object#hash(hasher)`

def path : String #
def to_s(io : IO) : Nil #
Description copied from struct Struct

Same as `#inspect(io)`.

def to_unsafe : Pointer(LibC::Sockaddr) #